@charset 'UTF-8';

@use '../../node_modules/normalize.css/normalize.css';

$font-family: 'Arial', sans-serif;

$color-white: #ffffff;
$color-black: #000000;

$color-bg: #073b4c;
$color-1: #ef476f;
$color-2: #ffd166;
$color-3: #06d6a0;
$color-4: #118ab2;

$color-flap: #1f1f1f;
$color-flap-darker: #161616;


* {
  box-sizing: border-box;
  padding: 0;
  margin: 0;
  border: 0;
  font-family: $font-family;
  line-height: 1.2;
}

html,
body {
  width: 100%;
  height: 100%;
}

body {
  display: grid;
  place-items: center;
  background-color: $color-bg;
  color: $color-white;
}

.clock {
  display: flex;
}

.number {
  position: relative;
  display: grid;
  width: 10vw;
  height: 15vw;
  border-radius: 1vw;
  background: linear-gradient($color-flap-darker 50%, $color-flap 50%);
  box-shadow: 0 0 12px rgba($color-black, .3);
  font-size: 12vw;
  font-weight: bold;
  text-align: center;

  + .number {
    margin-left: 1vw;
  }

  &:nth-child(2n) {
    + .number {
      margin-left: 2.5vw;
    }
  }

  .base,
  .flap {
    grid-row: 1 / 1;
    grid-column: 1 / 1;
  }
}

.base {
  display: grid;

  .top,
  .bottom {
    position: relative;
    grid-row: 1 / 1;
    grid-column: 1 / 1;

    &::after {
      content: '';
      position: absolute;
      left: 0;
      width: 100%;
      height: 2px;
    }
  }

  .top {
    clip-path: inset(0 0 50% 0);

    &::after {
      top: calc(50% - 2px);
      background-color: $color-flap-darker;
    }
  }

  .bottom {
    clip-path: inset(50% 0 0 0);

    &::after {
      bottom: calc(50% - 2px);
      background-color: $color-flap;
    }
  }
}

.flap {
  display: none;
  backface-visibility: hidden;

  &.show {
    display: block;
    animation: flip .6s ease-in-out 0s 1 normal forwards;
  }

  &.front,
  &.back {
    &::before {
      content: attr(data-content);
    }

    &::after {
      content: '';
      position: absolute;
      left: 0;
      width: 100%;
      height: 2px;
    }
  }
}

.front {
  clip-path: inset(0 0 50% 0);
  transform: rotateX(0deg);
  background-color: $color-flap-darker;
  border-radius: 1vw 1vw 0 0;

  &::after {
    top: calc(50% - 2px);
    background-color: $color-flap-darker;
  }

  &.show {
    animation-name: flip-top;
  }
}

.back {
  clip-path: inset(50% 0 0 0);
  transform: rotateX(-180deg);
  background-color: $color-flap;
  border-radius: 0 0 1vw 1vw;

  &::after {
    bottom: calc(50% - 2px);
    background-color: $color-flap;
  }

  &.show {
    animation-name: flip-bottom;
  }
}

@keyframes flip-top {
  from {
    transform: rotateX(0deg);
  }

  to {
    transform: rotateX(180deg);
  }
}

@keyframes flip-bottom {
  from {
    transform: rotateX(-180deg);
  }

  to {
    transform: rotateX(0deg);
  }
}
